unit getsysinfo_f;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ShlObj, JvComponent, JvDirectories;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    zavri: TButton;
    save_as: TButton;
    SaveDialog1: TSaveDialog;
    folders: TButton;
    variables: TButton;
    input_variable: TEdit;
    variable: TButton;
    jh: TJvDirectories;
    procedure zavriClick(Sender: TObject);
    procedure save_asClick(Sender: TObject);
    procedure foldersClick(Sender: TObject);
    procedure variablesClick(Sender: TObject);
    procedure variableClick(Sender: TObject);
  private
    { Private declarations }
  public
     procedure GetEnvVarList(List : TStrings);
     function GetEnvVar(const Name : String) : String;
     function GetSpecFolder(Index : integer) : String;
     function GetWindowsTempPath : String;
     function GetWinDir : String;
     function GetSysDir : String;
     function GetUser : String;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.GetEnvVarList(List : TStrings);
var p, startvar : PChar;
begin                             // zjitn seznamu systmovch promnch
  p := GetEnvironmentStrings;
  try
    startvar := p;
    while startvar^ <> #0 do
      begin
        List.Add(startvar);
        startvar := StrEnd(startvar) + 1;
      end;
  finally
    FreeEnvironmentStrings(p);
  end;
end;

function TForm1.GetEnvVar(const Name : String) : String;
var L : DWORD;
begin                             // zjitn systmov promnn "Name"
  L := GetEnvironmentVariable(PChar(Name), nil, 0);
  SetString(Result, nil, L);
  if GetEnvironmentVariable(PChar(Name), PChar(Result), L) <> L - 1 then
    RaiseLastWin32Error;
end;

function TForm1.GetWindowsTempPath : String;
var Name: PChar;
begin                             // zjitn TEMP-adrese (pro doasn soubory)
  Result := '';
  Name := #0;
  try
    GetMem(Name, MAX_PATH + 1);
    GetTempPath(MAX_PATH + 1, Name);
    Result := StrPas(Name);
  finally
    FreeMem(Name);
  end;
end;

function TForm1.GetWinDir : String;
var Name: PChar;
begin                             // zjitn Windows-adrese
  Result := '';
  Name := #0;
  try
    GetMem(Name, MAX_PATH + 1);
    GetWindowsDirectory(Name, MAX_PATH + 1);
    Result := StrPas(Name);
  finally
    FreeMem(Name);
  end;
end;

function TForm1.GetSysDir : String;
var Name: PChar;
begin                             // zjitn systmovho adrese
  Result := '';
  Name := #0;
  try
    GetMem(Name, MAX_PATH + 1);
    GetSystemDirectory(Name, MAX_PATH + 1);
    Result := StrPas(Name);
  finally
    FreeMem(Name);
  end;
end;

function TForm1.GetUser : String;
var Name: PChar;
    cesta : cardinal;
begin                             // zjitn jmna uivatele
  Result := '';
  Name := #0;
  cesta := MAX_PATH + 1;
  try
    GetMem(Name, cesta);
    GetUserName(Name, cesta);
    Result := StrPas(Name);
  finally
    FreeMem(Name);
  end;
end;

function TForm1.GetSpecFolder(Index : integer) : String;
var S : String;
    IDL : PItemIDList;
begin               // zjitn umstn specilnho adrese podle "indexu" v shjobj.pas
  Result := '';
  if Succeeded(SHGetSpecialFolderLocation(0, Index, IDL)) then
    begin
      SetLength(S, MAX_PATH);
      if SHGetPathFromIDList(IDL, PChar(S)) then
        Result := PChar(S);
    end;
end;

procedure TForm1.foldersClick(Sender: TObject);
begin
   memo1.Lines.Clear;
   memo1.Lines.Add('Podle indexu v shjobj.pas');
   memo1.Lines.Add('uivatel       : '+GetSpecFolder($0028));
   memo1.Lines.Add('dokumenty      : '+GetSpecFolder($0005));
   memo1.Lines.Add('appdata        : '+GetSpecFolder($001a));
   memo1.Lines.Add('loc_appdata    : '+GetSpecFolder($001c));
   memo1.Lines.Add('plocha         : '+GetSpecFolder($0000));
   memo1.Lines.Add('starmenu       : '+GetSpecFolder($000b));
   memo1.Lines.Add('start_prog     : '+GetSpecFolder($0002));
   memo1.Lines.Add('obliben       : '+GetSpecFolder($0006));
   memo1.Lines.Add('all_appdata    : '+GetSpecFolder($0023));
   memo1.Lines.Add('all_startmenu  : '+GetSpecFolder($0016));
   memo1.Lines.Add('all_start_prog : '+GetSpecFolder($0017));
   memo1.Lines.Add('all_plocha     : '+GetSpecFolder($0019));
   memo1.Lines.Add('windows        : '+GetSpecFolder($0024));
   memo1.Lines.Add('system         : '+GetSpecFolder($0025));
   memo1.Lines.Add('prog_files     : '+GetSpecFolder($0026));
   memo1.Lines.Add('');
   memo1.Lines.Add('Podle specialnch funkc');
   memo1.Lines.Add('do.soub.      : '+GetWindowsTempPath);
   memo1.Lines.Add('windows        : '+GetWinDir);
   memo1.Lines.Add('system         : '+GetSysDir);
   memo1.Lines.Add('uivatel       : '+GetUser);
   memo1.Lines.Add('verze_win      : '+IntToStr(GetVersion()));
   //memo1.Lines.Add('uivatel       : '+GetUser);
   memo1.Lines.Add('');
   memo1.Lines.Add('Podle komponenty JvDirectories');
   memo1.Lines.Add('dokumenty      : '+jh.Personal);
   memo1.Lines.Add('appdata        : '+jh.ApplicationData);
   memo1.Lines.Add('plocha         : '+jh.Desktop);
   memo1.Lines.Add('starmenu       : '+jh.StartMenu);
   memo1.Lines.Add('start_prog     : '+jh.Programs);
   memo1.Lines.Add('obliben       : '+jh.Favorites);
   memo1.Lines.Add('inter_cache    : '+jh.Cache);
   memo1.Lines.Add('inter_cookie   : '+jh.Cookies);
   memo1.Lines.Add('all_appdata    : '+jh.AllUsersAppData);
   memo1.Lines.Add('all_startmenu  : '+jh.AllUsersStartMenu);
   memo1.Lines.Add('all_start_prog : '+jh.AllUsersPrograms);
   memo1.Lines.Add('all_plocha     : '+jh.AllUsersDesktop);
   memo1.Lines.Add('windows        : '+jh.WindowsDirectory);
   memo1.Lines.Add('system         : '+jh.SystemDirectory);
   memo1.Lines.Add('prog_files     : '+jh.ProgramFiles);
   memo1.Lines.Add('cur_dir        : '+jh.CurrentDirectory);
   memo1.Lines.Add('fonty          : '+jh.Fonts);
end;

procedure TForm1.variablesClick(Sender: TObject);
begin
  Memo1.Lines.Clear;
  GetEnvVarList(Memo1.Lines);
end;

procedure TForm1.variableClick(Sender: TObject);
begin
  Application.MessageBox(PChar(GetEnvVar(input_variable.Text)),'GetSysInfo',MB_OK);
end;

procedure TForm1.zavriClick(Sender: TObject);
begin
  close;
end;

procedure TForm1.save_asClick(Sender: TObject);
begin
   if savedialog1.Execute then
     memo1.Lines.SaveToFile(savedialog1.FileName);
end;

end.

